﻿#ifndef DIALOG_H
#define DIALOG_H

#include <QDialog>
#include <QPainterPath>
#include <QSound>

class Dialog : public QWidget
{
    Q_OBJECT
    enum State{
        State_Title = 0,
        State_Main = 1,
        State_Result = 2
    };

public:
    Dialog(QWidget *parent = nullptr);
    ~Dialog() override;

protected:
    void keyPressEvent(QKeyEvent *event) override;
    void keyReleaseEvent(QKeyEvent *event) override;
    void paintEvent(QPaintEvent* e) override;

private:
    void initializeAll();
    void paintTitle(QPainter& p);
    void paintResult(QPainter& p);
    void paintMain(QPainter& p);
    void updatePos();
    qreal getDrawPosX(qreal posX);

    int state;
    QPointF playerPos;
    qreal playerV;
    qreal playerA;
    int boundCount;
    bool leftPressing;
    bool rightPressing;
    QPainterPath path;
    QImage imgWayback;
    QImage imgPlayer;
    QImage imgHome;
    QImage imgSample;
    bool showSample;
    int dotCount;
    std::vector<QPointF> dots;
    std::vector<QPoint> stars;
    QSound* sndNz1;
    QSound* sndDoor;
};

#endif // DIALOG_H
