﻿#ifndef XCUTTER_SOUNDPREVIEWER_H
#define XCUTTER_SOUNDPREVIEWER_H

#include <QObject>
#include <QTimer>
#include <cri_atom_ex.h>

class SoundPreviewer : public QObject
{
    Q_OBJECT
public:
    explicit SoundPreviewer(QObject *parent);
    ~SoundPreviewer();

    /* 指定した区間を再生する */
//    void PreviewStart(
//            const std::string& filepath,
//            int startTimeMs,
//            int durationMs
//            );
    /* 指定した時刻から最後まで再生する */
    void PreviewStart(
            const std::string& filepath,
            int startTimeSample,
            int sampleRate);

    void PreviewStop();

    bool IsPlaying();

signals:
    void UpdatePlaybackPos(int timeMs);

private slots:
    void preciseTimerTimeout();
    void preciseFadeOutTimerTimeout();
    void statusCheckTimeout();

private:
    /* 再生終了タイミングを指定するための正確なタイマー */
    QTimer* preciseTimer;
    /* フェードアウト開始時刻を指定するための正確なタイマー */
    QTimer* preciseFadeOutTimer;
    /* 同音を連続再生しないようにするためのタイマー */
    QTimer* avoidMultiStartTimer;
    /* 再生位置などの状態を判定するタイマー */
    QTimer* statusCheckTimer;
    /* 直前に取得した再生時刻が0だったかどうか */
    bool previousPlaybackPosIsZero;
    CriAtomExPlayerHn player;
    CriAtomExVoicePoolHn pool_wave;
    CriAtomDbasId dbas_id;
    /* フェードイン・フェードアウト */
    CriAtomExTweenHn fadeout_tween;
    int fadeoutMsReserved;
};

#endif // XCUTTER_SOUNDPREVIEWER_H
